20260121		HTML: Attributes can't do floats.
				Wordpress: A little less htmlspecialchars in the debug function.
20251214		Wordpress: Better escaping of string variables.
20251201		Form2: Fix php 8.4 error about null.
20250918		Wordpress: Add get_meta to post object store.
20250917		Collection: Allow return of a subcollection key immediately.
20250421		Form2: Fix missing minlength attribute.
20250326		Form2: Add correct min and max handling for date inputs.
20250319		Wordpress: Allow for checking of the is_multisite function. For legacy installs.
20250210		PHP 8.2 compat fixes
20240902		Worpdress: remove EDD https workaround. Deprecated.
20240902		Form: Allow setting of checkboxes value() with an array.
20240511		Worpdress: 8.2 form warning
20240213		Wordpress: Add extra nonce checking when outputting forms.
20231210		Form2: Make required an attribute that does not have a value, only a key.
20231202		Form2: Add test for data function
20230918		Wordpress: Add function to disable automatic nonce, for example when handling ajax requests.
20230913		Wordpress: Return the post if no nonce.
20230906		Add Wordpress form noncing.
20230809		Fix current_url() when the host has the port.
20230503		PHP 8.2 compat fixes
20230420		PHP 8.2 compat fixes
20230419		PHP 8.2 compat fixes
20230321		Wordpress: Escape the form action.
20230225		Form2: Add color input;
20230205		Mail: Fix ArgumentCountError.
20230104		Tree: Use return for count for php8.1
20221214		Collection: fix 8.1 compatibility
20220821		Form2: Add form checkbox class
20220811		Collection: reverse() retains the keys.
20220717		Form2: Buttons do not self close.
20220717		Form2: Add Bootstrap 5 support
20220619		Wordpress: Update EDD Updater
20220125		Form2: Forgot to rename the readonly trait.
				Fix table tests.
20220122		Form2: Rename the readonly trait due to the name "readonly" being reserved in php8.1. The function within are the same, though.
20211109		Wordpress: Update EDD Updater
20211017		Table: Use headers attribute for td cells.
20210906		Wordpress: Fix debug sprintf calls.
20210810		Form2: Fix options trait pointing to form()
20210701		Form2: Update sprintf calls for php8 compatibility.
20210615		Wordpress: fix base URL.
20210216		Form2: Fix checkbox value incorrectly reported using get_post_value().
20210205		Wordpress: Add action name overrides.
20210122		Form2: Fix description css_class error.
20210120		Wordpress: New mail class with phpmailer location.
20210119		Wordpress: Show the custom debug URL.
20210110		Form2: More Bootstrap4 work.
20210105		Form2: Add more bootstrap4 customizing.
20210104		Form2: Add bootstrap4 class to output Bootstrap 4 friendly html.
20200617		Wordpress: Use wp_salt().
20200608		Wordpress: Allow form display_form_table() function to accept inputs.
20200402		Wordpress: Update EDD updater.
20200223		Wordpress: Assume empty group slug for plugin pack.
20190812		Base: Fix extra :80 for https/http current_url when using internal proxies.
20190716		Wordpress: Added code for Option (local) storage.
20190607		Wordpress: Add filter for debugging file path.
20190414		Use clone for loading object stores.
20190411		Wordpress: Update EDD updater
20190404		form2: Add stripslashes() filter to text and textarea.
20190331		collection: to_array will handle ALL collections.
20190314		Wordpress: Workaround for serialized options not being saved due to caching.
20190222		Wordpress: No more protected properties.
20190119		Mail: Allow attachment encoding and mime type.
20190117		Fix prefix renamer script.
20181115		form2: Add the pattern() method to text inputs.
20181114		form2: do not stripslashes from values.
20181107		Added collection->has_value, which is the same as in_array, but nicer to use.
20181103		Added rename_prefix and rename_suffix, depending on how one wishes to rename the namespaces.
20180911		Wordpress: New EDD updater
20180708		Collection add import_array()
20180707		Collection: Deep convert during to_array().
20180703		Fix Wordpress EDD workaround warning.
20180611		Make static delete() function on object_store traits into normal function.
20180504		Wordpress: Fix _() command that doesn't exist. But does...
20180425		Wordpress debug trait now has filter to allow the text to be modified.
20180413		Added mail trait.
20180411		Form: Allow select input to display as an input.
20180302		wordpress message boxes take text() instead of _()
20180218		Add containers to form items when outputting as a string.
20180207		Check the scripts/upgrade directory for the new check_deprecated_functions script that will help you remove obsolete methods.
				Removed never used option_f().
20180206		Do not use AND anymore. Use &&.
20180126		Do not unserialize a db object if it is already unserialized.
20171208		Update Wordpress updater.
20171123		Wordpress tabs: Display the exception nicely.
20171028		Better Wordpress debugging strings.
20171019		Form Range input accepts float steps.
20171015		Collection flush() should return itself.
				Object store: key made unique.
				Object store: add reload()
20171002		Removed yes_no()
				Removed download()
				Removed check_plain()
				Removed human_bytes()
				Removed human_time()
				Removed human_time_span()
				Removed is_private_ip()
				Removed mime_type()
				Removed stacktrace()
				Removed strip_post_slashes()
				Split out Wordpress actions to their own trait.
				Added wordpress remove_action() and remove_filter().
20170901		Wordpress debug trait: Ignore sprintf errors.
20170829		Make current_url() proxy aware.
20170810		Wordpress EDD updater 1.6.14
20170704		Wordpress: Use legend OR label when displaying forms.
20170602		Wordpress: Added javascripting of plugin pack.
20170421		Wordpress: Force loading of PHPmailer class from WPINC.
20170322		Add Wordpress Post object store.
20170224		Wordpress EDD updater.
20170221		Clean up tests. Readd wpautop.
20170217		Remove all thirdparty classes.
				Remove add_query_arg and remove_query_arg
				Remove drupal
				Remove wpautop
20170216		Wordpress: EDD updater ignore invalid statuses some other place also.
20170216		Remove PHPmailer class completely.
20170215		Wordpress: EDD updater ignore invalid statuses.
20170201		Wordpress: Better EDD handler code.
20170131		Wordpress: Updater updated.
20170118		Wordpress: Correctly detect several IPs
20170117		Updated EDD Updater.
20170106		Fix debug file URL.
20161230		Updated EDD Updater.
20161228		Updated PHPmailer class.
20161219		Wordpress: Catch phpmailer exception when loading mail.
20161211		Form: Check if input needs to output a desc.
20160718		Wordpress: Newer updater.
20160630		Wordpress: db trait should use static:: not self::.
20160621		Form: File input has accepts() function for restricting file types.
20160414		Wordpress: Allow updated SSL workaround to be forced on.
20160330		Wordpress: Updater has built in Redhat SSL Workaround.
20160210		Wordpress: Message boxes should be dismissable.
20160207		Wordpress: wp_die should not double output messages.
20160204		Wordpress: edd_admin_license_tab_text
20160112		form: select inputs can now be sorted.
20160102		Deleted Wordpress options_object class.
20160102		Added object_stores trait to replace Wordpress Options_Object.
20151227		Wordpress: Removed old tabs functionality. Use only the tabs classes now.
20151227		Wordpress: Split tabs into nav tabs and subsubsub tabs.
20151225		Wordpress: Added menu_page() instead of add_submenu_page() methods.
20151225		form: Old form class retired. form() is now an alias for form2().
20151225		form2: Added sort order trait to inputs.
20151225		Wordpress: Added deprecated_function().
20151224		Wordpress: Allow tabs to be sorted using ->order();
20151223		Wordpress: Update EDD updater. Less validity checks. Better fail message.
20151222		Wordpress: Added row_actions();
20151221		Wordpress: Added message boxes.
20151221		Wordpress: Removed send_mail(). Use ->mail() instead.
20151215		Wordpress: Allow db object to load several IDs at once.
20151206		Wordpress: Table grouping + js.
20151203		Wordpress tables: Remove hover effect.
20151202		Wordpress: Do not base64 options object.
20151129		HTML: Added data convenience method and test.
20151106		Collections/html: Redone handling, with test.
20151105		Wordpress: add wp_editor form2 input type.
20151028		Wordpress: do not activate pack plugins if no action is selected.
20151028		Wordpress: prevent array_intersect warning if the user does not have capabilities on this blog.
20151025		Wordpress: Bulk action column has a unique ID.
20151024		Wordpress: Add Options_Object class.
20151009		Wordpress: Update plugin pack table.
20151003		Wordpress: More detailed debug trait.
20151003		Wordpress: Allow custom directory for language file.
20151002		Wordpress: use get_current_user_id() to return the current user's ID.
20150804		Moved to bitbucket.
20150725		Wordpress: Allow saving debug info to file.
20150721		Wordpress: get_user_capabilities and user_has_roles.
20150711		Wordpress plugin pack table allows selecting of checkboxes via plugin name.
20150708		Wordpress updater has its own namespace.
20150707		Wordpress tabs are now elements also.
20150624		Update Wordpress updater to 1.6
20150608		Wordpress plugin pack: allow plugin grouping by specifying @group in comment.
20150604		Wordpress debug trait now escapes the variables.
20150519		Mail: add sprintf support to the html, subject and text methods.
20150518		Table: Add titlef convenience method.
20150511		Fix harmless warning in Wordpress plugin pack.
20150507		Added drupal db_load() method.
20150424		Form2: container->input() returns container inputs also. Including test.
20150419		Added textarea_to_array function.
20150409		Do not clone the Wordpress wpdb upon insert. Let's hope that bug is fixed...
20150209		Collection->collection() added.
20150208		Wordpress udpater: Don't freeze if the server cannot be reached.
20150204		Wordpress widefat table has hover effect on rows.
20150202		Wrap the Wordpress input table fieldsets in a div.
20150202		Wordpress form table fieldset legends are displayed as plain h3.
20150116		array_rekey works with objects as values.
20150113		Wordpress forms should use the current scheme.
20150112		Wordpress debug flushes contents only if available. Thanks Flynsarmy.
20141228		Return false if no instance is available.
20141205		Plugin pack must call internal plugin methods.
20141204		Added scripts/sdk_restore.sh. Updated rename and update scripts.
20141203		Removed SDK versioning from Wordpress base.
20141203		Added scripts/sdk_update.sh
20141201		Added scripts/sdk_rename.sh
20141116		Form2: Fix radios input.
20141113		Wordpress: Plugin pack uses a get_plugin_classes action.
20141109		Wordpress: New EDD updater version.
20141103		Wordpress: Updater only needs one key. Checks less often.
20141030		Table: Element attribute modifications return this.
20141029		Wordpress: Updater works with multisites properly.
20141028		Wordpress: Plugin pack download link.
20141028		Wordpress: Plugin pack cleans plugin duplicates.
20141018		Wordpress: Fix action execute() and set_boolean.
20141016		Wordpress: Allow force new version check.
20141016		Wordpress: Plugin pack ignores non-existent plugins better.
20141013		Wordpress: Better plugin URL http/https handling.
20140928		Wordpress: Plugin pack fixes. paths(). Path fixes.
20140918		Wordpress: Added EasyDigitalDownloads licensing + updater support.
20140910		Form2: file input has not value.
20140903		Form2: Number input allows negative numbers.
20140822		Form2: append_prefix() now takes arrays as parameters also.
20140717		Wordpress plugin pack plugins are loaded with correct filename.
20140716		Fix uninstall for Wordpress plugin pack.
20140715		Fixed old form namespace.
20140711		form2: get_raw_post_value()
20140708		Wordpress: gmt_offset()
20140612		Wordpress: better path compatability with Windows servers.
20140611		Added human_bytes()
20140610		Added collections/sort_by_key
20140606		current_url fix for naughty webhosts that have HTTPS set to "Off".
20140518		Wordpress get_site_option default behaviour.
20140512		Fixed form2: clashing validation trait in some versions of PHP.
20140510		wordpress
20140508		Fixed form2 containers validation.
20140504		collections\html added.
20140502		wordpress
20140501		wordpress\traits\debug
20140427		wordpress\actions\action class.
20140418		wordpress wp_die()
20140413		wordpress - new roles handling
20140412		wordpress/db trait - fixed insert bug.
20140406		wordpress
20140331		Fixed Drupal db_aware_object path.
20140218		form2
20140203		Wordpress form
20140114		current_url SSL workaround for Microsoft IIS. *sigh*
20140110		Fixed add() bug in tree.
20140106		collections\collection.
20131211		wordpress
20131210		wordpress
20131209		tree class added.
20131112		form2
20131111		Check for mb extension before strtolower and strtoupper
20131109		form2
20131019		wordpress table top()
20131018		wordpress
20131016		wordpress roles, wordpress table bulk actions
20131015		form2
20131009		form2
20131008		current_url recognized HTTPS properly.
20131007		wordpress\base
20131006		wordpress\tabs
20131005		collections\collection
20131004		wordpress
20131002		collections\collection
20131001		form2
20130929		form2
20130925		form2
20130910		form2
20130902		wordpress/tabs improvements.
20130826		breadcrumb fix.
20130825		is_private_ip()
20130820		form2
20130819		form2
20130815		form2
20130814		form2
20130812		Version bump.
20130809		wordpress\tabs.
20130809		wordpress, human_time(), human_time_span().
20130807		form2
20130806		form2
20130803		table.
20130730		form2 select count(), breadcrumbs, table.
20130729		html\element
20130723		form2, instance() fixed, is_email checks for empty, mail bcc, wordpress\\traits\\foundation.
20130722		wordpress\\base
20130719		Unit tests using phpunit. Navigation class. Default wordpress sv language file.
20130717		add_query_arg and remove_query_arg
20130716		base::current_url disabled when running CLI.
20130712		form2 \n
					wpautop()
20130702		form2
20130606		form2
20130604		current_url
20130530		wordpress tabs.
20130527		table
20130524		form2
20130515		mail \n
					New: temp_directory() and temp_file().
20130507		Table.
20130506		Wordpress tabs. \n
					HTML namespace. \n
					New: uuid().
20130505		New: Wordpress tabs accept parameters \n
					New: Wordpress CLI.
20130504		New: string_to_emails() added $mx parameter.
20130501		array_rekey: force conversion of arrays to arrays (from objects).
20130430		Added thirdparty/phpmailer.
20130426		implode_html has switch the parameter order. $array is now first.
